#!/usr/bin/perl 

###############################################################################
##OCS inventory Linux Agent
##Copyleft Pascal DANEK 2005
##Web : http://ocsinventory.sourceforge.net
##
##Modified by Vincent Danjean for Debian
##
##This code is open source and may be copied and modified as long as the source
##code is always made freely available.
##Please refer to the General Public Licence http://www.gnu.org/ or Licence.txt
################################################################################

#Path definition
my $install_path = "/etc/ocsinventory-client";
my $varlib_path = "/var/lib/ocsinventory-client";
my $sample_path = "/usr/share/ocsinventory-client";

#################################################
#Installation script for OcsInventory Linux Agent
#################################################
use XML::Simple;
use Compress::Zlib;
use Compress::Zlib;
use LWP::UserAgent;
use Net::IP qw(:PROC);
use Getopt::Std;
################
#THE SUBROUTINES
################

getopts('n:t:');

if ($opt_n) {
    $export="http";
} else {
    $export="local";
}

sub _method{
	#Local or export http?
	#If local, user will have to run the agent himself, and tranfer the compressed inventory on the ocs web server
	$err = 0;
	while(!($err)){
#		print "Wich method will you use to generate the inventory (http/Local): ";
		($export=~/^http$|^local$/i)?$err=1:print "\nChoose a valid method (http ou local)\n";
	}
	#Server name
	#'Local' if not connected to the network
	if($export=~/http/i){
#		print "\nServer name : ";
		chomp($ServerName=$opt_n);
	}else{
		$ServerName='local';
	
	}
}	


#Creation of Device ID
sub _id{
	#Generation de l'identifiant
	chomp($Device=`hostname`);
	($YEAR, $MONTH , $DAY, $HOUR, $MIN, $SEC)=(localtime (time))[5,4,3,2,1,0];
	$DeviceID=sprintf "%s-%02d-%02d-%02d-%02d-%02d-%02d",  $Device, ($YEAR+1900), ($MONTH+1), $DAY, $HOUR, $MIN, $SEC;
}
	

#Request for auto-update
sub _update{
	$fin=1;
	while($fin){
#		print "Will you activate the auto-update ? (y/n) : ";
		chomp($AuthUpdate="n");
		if($AuthUpdate=~/^y$|^n$/i){
			$fin=0;
			$AuthUpdate=~/^y$/?($AuthUpdate=1):($AuthUpdate=0);
		}
	}
}

sub _tag{
	#It's possible to put a file into the installation directory to be more explicit with the user concerning the tag nature.
	#Just put a text file with the keyword of the tag (exemple : service, unitid....)
#	if(-f "label"){
#		open LABEL , "label";
#		chomp($label=<LABEL>);
#		close LABEL;
#	}
	
#	printf("Type the %s or return : ", $label?$label:'tag');
	$tag="";
	if ($opt_t) {
		chomp($tag=$opt_t);
	}
}


#####
#MAIN
#####

####################
#Looking for context
####################

	&_method;
	&_update;
	&_tag;

	#Get the Device ID
	if(-r "$install_path/ocsinv.conf"){
		#Reading configuration file
		$xmlconf = XMLin("$install_path/ocsinv.conf", SuppressEmpty => undef);
		$DeviceID = $xmlconf->{DEVICEID};
		
	}
	if(-r "$varlib_path/ocsinv.adm"){
		#Reading account informations file
		$xmladm=XMLin("$varlib_path/ocsinv.adm", SuppressEmpty => undef, , ForceArray => ['ACCOUNTINFO']);
		$i=0;
		while($xmladm->{ACCOUNTINFO}->[$i]->{KEYNAME}){
			$account{$xmladm->{ACCOUNTINFO}->[$i]->{KEYNAME}} = $xmladm->{ACCOUNTINFO}->[$i]->{KEYVALUE};
			$i++;
		}
	}
		
		#Device ID check
		chomp($Device=(`hostname`));
		unless($DeviceID=~/$Device-(\d{4})-(\d{2})-(\d{2})-(\d{2})-(\d{2})-(\d{2})/){
 			&_id;
		}
		else{
			if(!(($1>=2004)&&($1<2020)&&($2>=1)&&($2<=12)&&($3>=1)&&($3<=31)&&($4>=0)&&($4<=23)&&($5>=0)&&($5<=59)&&($6>=0)&&($6<=59))){
				&_id;
			}
		}



##########
#Writings
##########
#directories creation
#Installation directory

#writing of ocs.conf
$xmlconf{'DEVICEID'} = [ $DeviceID ];
$xmlconf{'OCSFSERVER'} = [ $ServerName ];
$xmlconf{'DMIVERSION'} = [ "1" ];
$xmlconf{'IPDISCOVER_VERSION'} = [ "1" ];
$xmlconf{'UPDATE'} = [ "1" ] if $AuthUpdate;
$xml = XML::Simple::XMLout( \%xmlconf, RootName => 'CONF' );
open CONF, ">$sample_path/ocsinv.conf";
print CONF $xml;
close CONF;

open ADM, ">$varlib_path/ocsinv.adm" or warn "Cannot create account info file\n";
$xmladm{'ACCOUNTINFO'}[0]{'KEYNAME'} = [ "TAG" ];
$xmladm{'ACCOUNTINFO'}[0]{'KEYVALUE'} = [ $tag ];
$xml=XML::Simple::XMLout( \%xmladm , RootName=> "ADM");
print ADM $xml;
close ADM;









